<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * --------------------------------------------------------------------
 * Centerblock mxTabs 1.1 for pragmaMx 0.1.10
 * written by (c) 2008 Siggi Braunert, http://www.sb-websoft.com
 * --------------------------------------------------------------------
 **/
if (!defined("mxMainFileLoaded")) die ("access denied");

mxSessionSetVar('tabstyledescr', $_CONSTANTS);

class mxTabs
{
	var $blocks = array();
 	var $row = array();
 	var $data = array(); 
 	var $message = "&nbsp;";
 	// rss adds
 	var $rss_data = array();
 	var $rss_object;
 	//
 	var $default = array(); 
 	var $constants = array(); 
 	var $forbidden = array('block-AdminAlert.php', 'block-AdminNews.php', 'block-vkp_News_Lastarticles.php', 'block-vkp_News_Login.php',
 	'block-vkp_News_Options.php', 'block-vkp_News_Poll.php', 'block-vkp_News_Rating.php', 'block-vkp_News_Related.php');

 	function mxTabs()
 	{
  		$this->constants = mxSessionGetVar('tabstyledescr');  
  		mxSessionDelVar('tabstyledescr');
  		if (file_exists(MX_THEME_DIR . '/blocks/mxTabs/settings.php')) {
			include(MX_THEME_DIR . '/blocks/mxTabs/settings.php');   		
  		}
  		else {
  			include('blocks/mxTabs/settings.php');  
  		}
  		include('blocks/mxTabs/config.php');
  		$this->default = $mx_tabs_cnf; 
  		$this->rss_data = $mx_tabs_cfg['rss']; 
  		if ($this->rss_data['adds'] == false) {
  			$this->rss_data['desc'] = false;
  		}
  		$this->dummy = $nice_day;
  		$this->load_blocks(); 
  		if(isset($_POST['form_main'])) {
   			$this->update_bids($_POST['form_main']);
  		}
  		if(isset($_POST['form_settings'])) {
   			$this->update_conf();   
  		}   
		if (class_exists('RSS_feed2')) {
			$this->rss_object = new RSS_feed2();
		}
	} 
 
 	function load_blocks()
 	{
  		$array = array();
  		$sql = "SELECT * FROM ".$GLOBALS['prefix']."_blocks ORDER BY title ;";
  		$result = sql_query($sql);
  		while ($row = sql_fetch_assoc($result))	{
   			if(in_array($row['blockfile'], $this->forbidden)) {
    				continue;   
   			}   
   			if ($row['blockfile'] != "block-mxTabs_center.php") {   
    				$array[] = $row;
   			}
   			else { 
    				$this->row = $row;
    				$this->data = $this->get_data();   
   			}   
  		}
  		$this->blocks = $array;
 	}

 	function get_data()
 	{
  		$ret = array('bids' => "", 'conf' => ""); 
  		$content = empty($this->row['content']) ? "|" : $this->row['content']; 
  		$pieces = explode("|", $content); 
  		$ret['bids'] = trim($pieces[0]);   
  		if(empty($pieces[1])) {
   			$ret['conf'] = 'default';  
  		}   
  		else {
   			$ret['conf'] = trim($pieces[1]); 
  		}  
  		return $ret; 
 	} 

 	function get_tabcontent()
 	{ 
  		$array = array();
  		$ret = array();   
  		$_bids = $this->data['bids']; 
  		if(!empty($_bids)) {
   			$array = explode(",", $_bids);  
   			foreach($array as $bid) {  
    				$result = @sql_query("SELECT title, content, url, position, active, refresh, time, blockfile FROM ".$GLOBALS['prefix']."_blocks WHERE bid='".$bid."' ;");
    				list($title, $content, $url, $position, $active, $refresh, $time, $blockfile) = sql_fetch_row($result);
    				$ret[] = array('bid' => $bid, 'title' => $title, 'content' => $content, 'url' => $url, 'position' => $position, 'active' => $active, 'refresh' => $refresh, 'time' => $time, 'blockfile' => $blockfile);    
   			}  
  		}
  		if(count($ret) == 0) {
   			$ret[] = $this->dummy; 
  		}  
  		return $ret;  
 	}  

 	function get_rsscontent($url) {
		$content = "";
		if ($this->rss_data['adds'] == true && isset($this->rss_object)) {
			$url = mxCutHTTP($url);
			$this->rss_object->Set_URL($url);
			$this->rss_object->Set_Limit($this->rss_data['limit']); 
			//$mx_tabs_rss['image'] = true; // Bilddaten zeigen (false = nein, true = ja) ...eigentlich sollte das in der config stehen...
			$this->rss_object->Show_Image(false); // ...aber TODO :hier spinnt anscheinend die RSS_feed Class :( ...muss erstmal draussen bleiben...also auf FALSE ! 
			$this->rss_object->Show_Description($this->rss_data['desc']); 
 			$content = $this->rss_object->Get_Results();
			$content = str_replace('target="_blank"', 'target="new"', $content);
		}
		else {
			$content = mxGetRssContent($url);
		}	
 		return preg_replace('~&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)~', '&amp;', $content); // auf richtige Maskierung des '&' Zeichens in URL pruefen und ggf. korrigieren 
 	}
 	
 	function get_rssdata($tab = array()) 
 	{
		$output = "";
		$past = time() - $tab['refresh'];
        	if (($tab['time'] < $past) || isset($_GET['feedsupdate'])) {
          	$output = $this->get_rsscontent($tab['url']);
          	$GLOBALS['mxSkipSqlDetect'] = true;
          	$result = sql_query("update " . $GLOBALS['prefix'] . "_blocks set content='" . mxAddSlashesForSQL($output) . "', time='" . time() . "' where bid='" . $tab['bid'] . "'");
          	if (MX_IS_ADMIN && (empty($output) || !$result)) {
              	$output = _RSSPROBLEM . '<br /><a href="' . $tab['url'] . '" target="new">' . mxCutString($tab['url'], 50, '..', '/') . '</a>';
            }
        	}
		else {
			$output = $tab['content'];
		}
		if (class_exists('pmzThemeTPL') && $this->rss_data['adds'] == false) {
			if (!isset($html_object)) {
				$html_object = new pmzThemeTPL(); 
			}
			if(!empty($output)) {
				$output = $html_object->show_list($tab['title'], $output);					
			}
		}
 		$updating = (MX_IS_ADMIN && !empty($output)) ? "<p style='font-size:80%;'><a href='./?feedsupdate'>" . _MXTABS_RSSFEEDSUPDATE . "</a></p>" : "";
  		return $output . $updating;
 	}
 	
 	function get_settings()
 	{
  		if (@function_exists("mxTabs_get_config")) {
   			$conf = mxTabs_get_config(); 
  		}
  		else {
   			$conf = $this->default; 
  		}  
  		return $conf;
 	} 

 	function update_conf()
	{
  		$posted_values = "";
  		$sep = "";
  		$content = ""; 
  		if (isset($_POST['xdefault'])) {
   			if($_POST['xdefault'] == 1) {   
    				$content = $this->data['bids']."|default";
   			}
   			else {
    				foreach($_POST as $key=>$var) {
     				if (substr($key, 0, 4) == "cnf_") {
      					if (strlen(trim($var)) == 0) {
       						$var = $this->default[substr($key,4)];  
      					}       
      					$posted_values .= $sep.trim($var); 
      					$sep = "::";     
     				}     
    				}    
    				$content = $this->data['bids']."|".$posted_values;
   			}   
  		} 
  		$sql = "UPDATE ".$GLOBALS['prefix']."_blocks SET content = '".$content."' WHERE bid='".$this->row['bid']."' ;";
  		@sql_query($sql);
  		if (sql_affected_rows() > 0) {
   			header("Location: index.php");   
  		}  
 	} 

 	function update_bids($f)
 	{
  		$bids = array();
  		$new_bids = "";
  		$content = "";
  		foreach($this->blocks as $_block) {
   			$bids[] = $_block['bid'];  
  		}  
  		$this_bids = array_unique(explode(",", _clr($f['bids'])));
  		$array_isect = array_intersect($this_bids, $bids);
  		if (count($array_isect) > 0) {
   			foreach($array_isect as $isect) {  
    				if (!empty($new_bids)) {    
     				$new_bids .= ",";    
    				}    
    				$new_bids .= $isect;  
   			}
  		}  
  		$content = $new_bids."|".$this->data['conf'];
  		$sql = "UPDATE ".$GLOBALS['prefix']."_blocks SET content = '".$content."' WHERE bid='".$this->row['bid']."' ;";
  		@sql_query($sql);
  		if (sql_affected_rows() > 0) {
   			header("Location: index.php");   
  		}  
 	} 

 	function form_main()
 	{
  		?>
   		<script type="text/javascript">
    		//<![CDATA[
    		Array.prototype.contains = function (elem) {
    			var i;
    			for (i = 0; i < this.length; i++) {
    				if (this[i] == elem) {
       				return true;
    				}
    			}
      		return false;
     	};

     	function addbid(identifier) {
      		var data = document.getElementById(identifier).firstChild.data;   
      		var inpbids = document.getElementById("inpbids");
      		var arr = inpbids.value.split(",");
      		if (arr.contains(data)) {
       			alert("<?php echo _MXTABS_BLKALREADYSELECTED ?>");
      		}
      		else {       
       			if (inpbids.value.length > 0) kommata = "," ; else kommata = "";      
        		document.getElementById("inpbids").value = inpbids.value + kommata + data;
      		}       
      		return false;      
     	}
    		//]]>
   		</script> 
   		<form action="index.php?mxtabs=admin" method="post">
    		<div>
     		<span style="font-weight:bold;"><?php echo _MXTABS_BLOCKIDS ?></span>
     		<br />
     		<input id="inpbids" maxlength="40" name="form_main[bids]" size="40" value="<?php echo $this->data['bids'] ?>" type="text" />
     		<input type="submit" name="form_main[submit]" value="<?php echo _SAVE ?>"  />    
     		<div style="font-size:90%; padding-bottom: 5px;"><?php echo _MXTABS_IDSINORDER ?>&nbsp;<?php echo _MXTABS_EDITBLOCKINFO ?></div>
    		</div>    
    		<div>
     		<div style="font-style:italic;"><?php echo $this->message ?></div>   
     		<table width="100%">
      			<tr>      
       				<th style="width:10%; text-align:center;">&nbsp;ID&nbsp;</th>
					<th style="width:53%; text-align:center; padding-left:10px;"><?php echo _MXTABS_BLOCKNAME ?></th>
					<th style="width:19%; text-align:center;"><?php echo _MXTABS_POSITION ?></th>
					<th style="width:15%; text-align:center;"><?php echo _MXTABS_ACTIVE ?></th>     
					<th style="width:25px">&nbsp;</th>
				</tr>    
     		</table>    
    		</div>    
    		<div style="overflow:auto; height:180px;"> 
     		<table width="100%">
      			<?php foreach($this->blocks as $block) :?>
      			<tr>       
       				<td style="width:10%; text-align:center; font-weight:bold; padding-right:10px;"><a id="bid_<?php echo $block['bid'] ?>" href="admin.php?op=BlocksEdit&amp;bid=<?php echo $block['bid'] ?>" title="<?php echo sprintf(_MXTABS_EDITBLOCK, "'".$block['title']."'") ?>"><?php echo $block['bid'] ?></a></td>
       				<td style="width:55%; text-align:center;"><a href='javascript:void(0);' onclick="addbid('bid_<?php echo $block['bid']?>');" title="<?php echo _ADD ?>"><?php echo $block['title'] ?></a></td>
       				<td style="width:20%; text-align:center;"><?php echo _blkpos($block['position']) ?></td>
       				<td style="width:15%; text-align:center;"><?php echo ($block['active'] == 1) ? _YES : _NO ?></td>
      			</tr>       
      			<?php endforeach; ?>
     		</table>      
    		</div>
    		<div style="padding:10px 0 10px 10px;">
     		<input type="button" onclick="document.getElementById('inpbids').value='';" value="<?php echo _MXTABS_DELINPUT ?>" style="margin-right:15px;" />          
     		<input type="button" onclick="javascript:history.go(-1)" value="<?php echo _MXTABS_GOBACK ?>" />    
    		</div>    
   		</form>
  		<?php  
 	} 

 	function form_settings()
 	{
  		$settings = $this->get_settings();
  		$inuse = array();
  		$checked = 'checked="checked"';
  		$disabled = 'disabled="disabled"';
  		$checked_def = "";
  		$checked_usr = "";  
  		if ($this->data['conf'] == "default") {
   			$checked_def = $checked;
   			$inuse = $this->default;  
  		}
  		else {
   			$checked_usr = $checked;  
   			$disabled = "";
   			$inuse = $settings;  
  		}
  		?> 
   		<script type="text/javascript">
    	//<![CDATA[
     	function tab_change_modus() 
     	{
      		if (document.tabs.xdefault[0].checked == true) {
       			var status = true;
      		}
      		else {
      			var status = false;
      		}
     		<?php foreach($settings as $key=>$value) :?>
      			document.tabs.cnf_<?php echo $key ?>.disabled = status;   
     		<?php endforeach; ?>
      		if (status == true) {  
        		<?php foreach($this->default as $key=>$value) :?>
	 			document.tabs.cnf_<?php echo $key ?>.value = "<?php echo $value ?>";
				<?php endforeach ;?>
      		}
      		else {
       			<?php foreach($settings as $key=>$value) :?>
					document.tabs.cnf_<?php echo $key ?>.value = "<?php echo $value ?>";
       			<?php endforeach; ?>     
      		}      
     	}
    	//]]>
   		</script>   
   		<form name="tabs" action="index.php?mxtabs=admin" method="post">
    		<div style="font-size: 90%; padding:5px 0 0 5px;"><?php echo _MXTABS_SETTINGSINFO ?></div>    
    		<div style="padding:10px 0 0 5px; font-weight:bold;">
     			<?php echo _MXTABS_USEDEFSETS ?>    
     			<input type="radio" value="1" <?php echo $checked_def ?> name="xdefault" onclick="tab_change_modus();" /><?php echo _YES ?>&nbsp;  
     			<input type="radio" value="0" <?php echo $checked_usr ?>  name="xdefault" onclick="tab_change_modus();" /><?php echo _NO ?>   
    		</div>
    		<?php foreach($inuse as $key=>$value) :?>
     			<div style="padding:10px 0 0 5px;">
      				<div style="width:175px; float:left;"><?php echo $this->constants[$key] ?></div>    
      				<input <?php echo $disabled ?> type="text" maxlength="60" size="30" value="<?php echo $value ?>" name="cnf_<?php echo $key ?>" />  
     			</div>     
    		<?php endforeach; ?> 
    		<div style="padding:15px 0 10px 15px;">
     			<input type="submit" name="form_settings[submit]" value="<?php echo _EDIT ?>" style="margin-right:15px;" />
     			<input type="button" onclick="javascript:history.go(-1)" value="<?php echo _MXTABS_GOBACK ?>" />     
     			<span style="padding-left:25px;"><?php echo $this->constants['color_help_link'] ?>&nbsp;</span>   
    		</div>
   		</form>  
  		<?php 
 	}
} //endofclass

/**
 * RSS_feed Class einbinden und _handle_close_element-Methode ueberschreiben
 * zwecks xhtml-Validierung.
 * Neues Objekt wird in mxTabs-Class erzeugt
 */
if (file_exists(PMX_SYSTEM_DIR . '/class_RSS_feed.php')) {
	
	include_once(PMX_SYSTEM_DIR . '/class_RSS_feed.php');
	
	class RSS_feed2 extends RSS_feed {
	
		function _handle_close_element(&$p, &$element) {
        		if (!isset($outbuffer)) {
            		$outbuffer = "";
        		} ;
        		// Closing elements for all versions.
        		// Because the elements can appear in orders differing from each other
        		// the output is now created at the close of each of the critical elements.
        		$element = strtolower($element);
        		static $cnt;
        		switch ($element) {
            		case 'channel': // major elements -- define closing event
                	// put channel information on the top. This should work even if the channel close element
                	// occurs before the item tags
                	if ($this->showimage && $this->image['link']) {
                    	$outbuffer .= '<a href="' . $this->image["link"] . '" target="new"><img src="'
                     	. $this->image["url"] . '" border="0" alt="' . $this->image["title"] . '"></a><br />';
                	}
                	$outbuffer .= '<h2><a href="' . $this->channel["link"] . '" target="new">'
                 	. $this->channel["title"] . '</a></h2>';
                	if ($this->showdesc)  { 
                		$outbuffer .= $this->channel["desc"];
                	}
                	$outbuffer .= $this->output;
                	$this->output = $outbuffer;
                	$this->channel["link"] = "";
                	$this->channel["title"] = "";
                	$this->channel["desc"] = "";
                	$this->channelclosed = true;
                	$outbuffer = "";
                	break;
            		case 'image': // Image tags closed
                	// A little tricky here as image is often part of the channel container tags
                	// Some feeds close the channel element and then provide the image.
                	// Image has its own close element, unless the values are provided by Attributes!
                	if ($this->channelclosed) {
                    	// Put the image on the top
                    	if ($this->showimage && $this->image["link"]) {
                        		$outbuffer .= '<a href="' . $this->image["link"] . '" target="new"><img src="'
                         	. $this->image["url"] . '" border="0" alt="' . $this->image["title"] . '"></a><br />';
                        		$this->output = $outbuffer . $this->output;
                        		$outbuffer = "";
                    	}
                	}
                	break;
            		case 'item':
                	// Each item has its own close element
                	if ($this->flag) {
                    	// Initialize item list
                    	$this->output .= "<ul>";
                    	$this->flag = false;
                    	$cnt = 0;
                	}
                	if ($this->limit > $cnt || !$this->limit) {
                    	$this->output .= '<li><a href="' . $this->item["link"] . '" target="new">'
                     	. $this->item["title"] . '</a>';
                    	if ($this->showdesc) {
                        		$this->output .= "<br />\n" . $this->item["desc"] . "</li>\n";
                        	}
                    	else {
                    	 $this->output .= "</li>\n";
                    	}
                    	if ($this->limit > 0) $cnt++;
                	}
                	$this->item["link"] = "";
                	$this->item["title"] = "";
                	$this->item["desc"] = "";
                	break;
            		default: // ignore all other close elements
                	break;
        		}
    		}
	}
} // endofclass

function _clr($string, $char = " ") {
 	return str_replace($char, '', $string);
}

function _blkpos($ch) {
 	switch ($ch) {
  		case "l" : return _MXTABS_LEFT; 
  		case "r" : return _MXTABS_RIGHT;
  		case "c" : return _MXTABS_CENTERUP;
  		case "d" : return _MXTABS_CENTERDOWN;  
 	} 
}

if (!function_exists('is_block_Modules')) {
	function is_block_Modules($file)
	{
		if (isset($file)) {
			if (preg_match("/block-Modules/i", $file) || $file == '') {
				return 1;
			}
			else {
				return 0;
			}
		}
		return 0;
	}		
}

$mxTabs = new mxTabs();
?>
